package com.nanyan.securitylink.interceptor;

import com.nanyan.securitylink.common.Constant;
import com.nanyan.securitylink.common.MsgCode;
import com.nanyan.securitylink.entity.UserHeader;
import com.nanyan.securitylink.entity.UserThreadLocal;
import com.nanyan.securitylink.execption.HeaderException;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;
import org.springframework.web.servlet.HandlerInterceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Base64;


@Component
public class HeaderInterceptor implements HandlerInterceptor {
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {

        try{
            String accountName = getHeader(request, Constant.ACCOUNT);
            UserHeader userHeader = new UserHeader();
            userHeader.setAccountName(accountName);
            UserThreadLocal.set(userHeader);
        }catch (Exception e){
            e.printStackTrace();
            throw new HeaderException(MsgCode.LOGIN_FAILED);
        }
        return true;

    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {
        UserThreadLocal.remove();
    }
    public String getHeader(HttpServletRequest request, String key){
        String value = request.getHeader(key);
        if(StringUtils.isEmpty(value)){
            return "";
        }
        byte[] decodedBytes = Base64.getDecoder().decode(value);
        value = new String(decodedBytes);
        return value;
    }
}
